﻿using System.Drawing;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 컬럼 너비
        /// </summary>
        private const int COLUMN_WIDTH = 150;

        /// <summary>
        /// 행 높이
        /// </summary>
        private const int ROW_HEIGHT = 50;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            #region 이벤트를 설정한다.

            Paint += Form_Paint;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 폼 페인트시 처리하기 - Form_Paint(sender, e)

        /// <summary>
        /// 폼 페인트시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Paint(object sender, PaintEventArgs e)
        {
            int x = 10;
            int y = 10;

            DrawIconSample(e.Graphics, ref x, y, SystemIcons.Application, "Application");
            DrawIconSample(e.Graphics, ref x, y, SystemIcons.Asterisk   , "Asterisk"   );
            DrawIconSample(e.Graphics, ref x, y, SystemIcons.Error      , "Error"      );

            x = 10;

            y += 50;

            DrawIconSample(e.Graphics, ref x, y, SystemIcons.Exclamation, "Exclamation");
            DrawIconSample(e.Graphics, ref x, y, SystemIcons.Hand       , "Hand"       );
            DrawIconSample(e.Graphics, ref x, y, SystemIcons.Information, "Information");

            x = 10;

            y += ROW_HEIGHT;

            DrawIconSample(e.Graphics, ref x, y, SystemIcons.Question, "Question");
            DrawIconSample(e.Graphics, ref x, y, SystemIcons.Shield  , "Shield"  );
            DrawIconSample(e.Graphics, ref x, y, SystemIcons.Warning , "Warning" );

            x = 10;

            y += 50;

            DrawIconSample(e.Graphics, ref x, y, SystemIcons.WinLogo, "WinLogo");

            ClientSize = new Size(3 * COLUMN_WIDTH, 4 * ROW_HEIGHT);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 아이콘 샘플 그리기 - DrawIconSample(graphics, x, y, icon, iconName)

        /// <summary>
        /// 아이콘 샘플 그리기
        /// </summary>
        /// <param name="graphics">그래픽스</param>
        /// <param name="x">X 좌표</param>
        /// <param name="y">Y 좌표</param>
        /// <param name="icon">아이콘</param>
        /// <param name="iconName">아이콘 명칭</param>
        private void DrawIconSample(Graphics graphics, ref int x, int y, Icon icon, string iconName)
        {
            graphics.DrawIconUnstretched(icon, new Rectangle(x, y, icon.Width, icon.Height));

            int textY = y + (int)(icon.Height - graphics.MeasureString(iconName, this.Font).Height) / 2;

            graphics.DrawString(iconName, this.Font, Brushes.Black, x + icon.Width + 5, textY);

            x += COLUMN_WIDTH;
        }

        #endregion
    }
}